Attribute VB_Name = "DQHelper"
Option Explicit
'Globals
Public gCurrentSysName As String
Public gCommonErrorRC(100) As String    'string array for error text
Public gBigData As String               'Big String for Stress Test
Public Const gAppName = "DQ OCX/Automation Test"
Public ghFrmMain As Long       'Windows handle of main form
Public ghFrmAsyncRead As Long

'Useful Windows APIs
Public Const SWP_NOMOVE = 2
Public Const SWP_NOSIZE = 1
Public Const FLAGS = SWP_NOMOVE Or SWP_NOSIZE
Public Const HWND_TOPMOST = -1
Public Const HWND_NOTOPMOST = -2

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Function SetWindowPos Lib "user32" _
      (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, _
      ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Sub DspDQErr(ErrObj As Object, cwbrc As Long, Optional Title)
   'Displays each error contained in the cwb error object.
   'It also pulls the DQ API return code from this error message
   'and includes the description of the return code contained in the C header file
   '(cwbdqapi.h).  The header file is located in the CAWIN toolkit.
   '
   Dim ErrCount As Long
   Dim ErrText As String
   Dim sDQRC As String
   Dim I As Long
   
   If Len(Title) = 0 Then Title = "Data Queue Error"
   ErrCount = ErrObj.errorCount
   If (ErrCount > 0) Then
      For I = 1 To ErrCount
         Call ErrObj.cwbsvGetErrTextIndexed(I, ErrText)
         'grab the DQ return code text
         sDQRC = Mid(ErrText, Len(ErrText) - 3, 4)
         If Val(sDQRC) >= 6000 And Val(sDQRC) <= 6099 Then
            ErrText = ErrText & vbCrLf & vbCrLf & _
                        gCommonErrorRC(Val(sDQRC) - 6000)
         End If
         MsgBox ErrText, , Title
      Next I
   Else
      MsgBox "No errors contained in the cwb error object. The cwb return code is " _
               & Str(cwbrc), , Title
   End If

End Sub
Public Sub DspDQBoxErr(ErrObj As Object, cwbrc As Long, Optional Title)
   'Displays each error contained in the DATA QUEUE OCX error object.
   'It also pulls the DQ API return code from this error message
   'and includes the description of the return code contained in the C header file
   '(cwbdqapi.h).  The header file is located in the CAWIN toolkit.
   '
   Dim ErrCount As Long
   Dim ErrText As String
   Dim sDQRC As String
   Dim I As Long
   
   If Len(Title) = 0 Then Title = "Data Queue Error"
   ErrCount = ErrObj.GetErrorMessageCount
   If (ErrCount > 0) Then
      For I = 1 To ErrCount
         ErrObj.GetErrorMessageText I, ErrText
         If Len(ErrText) = 0 Then
            ErrText = "Unable to retrieve Error Message Text.  Error Count: " _
                       & Str(I) & " of " & Str(ErrCount)
         End If
         'grab the DQ return code text
         On Error GoTo SkipMsg
         sDQRC = Mid(ErrText, Len(ErrText) - 3, 4)
         If Val(sDQRC) >= 6000 And Val(sDQRC) <= 6099 Then
            ErrText = ErrText & vbCrLf & vbCrLf & _
                        gCommonErrorRC(Val(sDQRC) - 6000)
         End If
SkipMsg:
         MsgBox ErrText, , Title
      Next I
   Else
      MsgBox "No errors contained in the cwbDQbox control. The cwbDQbox return code is " _
               & Str(cwbrc), , Title
   End If

End Sub

Public Function SetCommonDQErrors(gCommonErrorRC() As String) As Boolean
   'Sets a string array with text for all DQ return codes
   'Indexed by RC
   
   If UBound(gCommonErrorRC) < 99 Then
      SetCommonDQErrors = False
      Exit Function
   End If
      
   gCommonErrorRC(0) = "Invalid attributes handle: CWBDQ_INVALID_ATTRIBUTE_HANDLE CWBDQ_START"

   gCommonErrorRC(1) = "Invalid data handle: " & _
                        "CWBDQ_INVALID_DATA_HANDLE      CWBDQ_START+1"
   
   gCommonErrorRC(2) = "Invalid queue handle : " & _
                       "CWBDQ_INVALID_QUEUE_HANDLE     CWBDQ_START+2"
   
   gCommonErrorRC(3) = "Invalid data queue read handle: " & _
                       "CWBDQ_INVALID_READ_HANDLE      CWBDQ_START+3"
   
   gCommonErrorRC(4) = "Invalid maximum record length for a data queue: " & _
                       "CWBDQ_INVALID_QUEUE_LENGTH     CWBDQ_START+4"
   
   gCommonErrorRC(5) = "Invalid key length: " & _
                       "CWBDQ_INVALID_KEY_LENGTH       CWBDQ_START+5"
   
   gCommonErrorRC(6) = "Invalid queue order                       : " & _
                       "CWBDQ_INVALID_ORDER            CWBDQ_START+6"
   
   gCommonErrorRC(7) = "Invalid queue authority                   : " & _
                       "CWBDQ_INVALID_AUTHORITY        CWBDQ_START+7"
   
   gCommonErrorRC(8) = "Queue title (description) is too long or cannot be converted: " & _
                       "CWBDQ_INVALID_QUEUE_TITLE      CWBDQ_START+8"
   
   gCommonErrorRC(9) = "Queue name is too long or cannot be converted: " & _
                       "CWBDQ_BAD_QUEUE_NAME           CWBDQ_START+9"
   
   gCommonErrorRC(10) = "Library name is too long or cannot be converted  " & _
                       "CWBDQ_BAD_LIBRARY_NAME         CWBDQ_START+10"
   
   gCommonErrorRC(11) = "System name is too long or cannot be converted " & _
                       "CWBDQ_BAD_SYSTEM_NAME          CWBDQ_START+11"
   
   gCommonErrorRC(12) = "Length of key is not correct for this data queue " & _
                        "or key length is greater than 0 for a LIFO or FIFO data queue " & _
                       "CWBDQ_BAD_KEY_LENGTH           CWBDQ_START+12"
   
   gCommonErrorRC(13) = "Length of data is not correct for this data queue.  Either the " & _
                        "data length is zero or it is greater than the maximum allowed " & _
                        "of 31744 bytes.  " & _
                        "CWBDQ_BAD_DATA_LENGTH          CWBDQ_START+13"
   
   gCommonErrorRC(14) = "Wait time is not correct                  : " & _
                        "CWBDQ_INVALID_TIME             CWBDQ_START+14"
   
   gCommonErrorRC(15) = "Search order is not correct               : " & _
                        "CWBDQ_INVALID_SEARCH           CWBDQ_START+15"
   
   gCommonErrorRC(16) = "Returned data was truncated               : " & _
                        "CWBDQ_DATA_TRUNCATED           CWBDQ_START+16"
   
   gCommonErrorRC(17) = "Wait time has expired and no data has been returned " & _
                        "CWBDQ_TIMED_OUT                CWBDQ_START+17"
   
   gCommonErrorRC(18) = "Command rejected by user exit program     : " & _
                       "CWBDQ_REJECTED_USER_EXIT       CWBDQ_START+18"
   
   gCommonErrorRC(19) = "Error in user exit program or invalid number of exit programs " & _
                       "CWBDQ_USER_EXIT_ERROR          CWBDQ_START+19"
   
   gCommonErrorRC(20) = "Library not found on system               : " & _
                       "CWBDQ_LIBRARY_NOT_FOUND        CWBDQ_START+20"
   
   gCommonErrorRC(21) = "Queue not found on system                 : " & _
                       "CWBDQ_QUEUE_NOT_FOUND          CWBDQ_START+21"
   
   gCommonErrorRC(22) = "No authority to library or data queue     : " & _
                       "CWBDQ_NO_AUTHORITY             CWBDQ_START+22"
   
   gCommonErrorRC(23) = "Data queue is in an unusable state        : " & _
                       "CWBDQ_DAMAGED_QUEUE            CWBDQ_START+23"
   
   gCommonErrorRC(24) = "Data queue already exists                 : " & _
                       "CWBDQ_QUEUE_EXISTS             CWBDQ_START+24"
   
   gCommonErrorRC(25) = "Invalid message length - exceeds queue maximum record length " & _
                       "CWBDQ_INVALID_MESSAGE_LENGTH   CWBDQ_START+25"
   
   gCommonErrorRC(26) = "Queue destroyed while waiting to read or peek a record " & _
                        "CWBDQ_QUEUE_DESTROYED          CWBDQ_START+26"
   
   gCommonErrorRC(27) = "No data was received                      : " & _
                        "CWBDQ_NO_DATA                  CWBDQ_START+27"
   
   gCommonErrorRC(28) = "Data cannot be converted for this data queue.  The data queue " & _
                        "can be used but data cannot be converted between ASCII and " & _
                        "EBCDIC.  The convert flag on the data object will be ignored.  " & _
                        "CWBDQ_CANNOT_CONVERT           CWBDQ_START+28"
   
   gCommonErrorRC(29) = "Syntax of the data queue name is incorrect.  Queue name must " & _
                        "follow AS/400 object syntax.   First character must be " & _
                        "alphabetic and all following characters alphanumeric  " & _
                        "CWBDQ_QUEUE_SYNTAX             CWBDQ_START+29"
   
   gCommonErrorRC(30) = "Syntax of the library name is incorrect.  Library name must " & _
                        "follow AS/400 object syntax.   First character must be " & _
                        "alphabetic and all following characters alphanumeric. " & _
                        "CWBDQ_LIBRARY_SYNTAX           CWBDQ_START+30"
   
   gCommonErrorRC(31) = "Address not set.  The data object was not set with with " & _
                        "cwbDQ_SetDataAddr(), so the address cannot be retrieved.  " & _
                        "Use cwbDQ_GetData() instead of cwbDQ_GetDataAddr()." & _
                       "CWBDQ_ADDRESS_NOT_SET     CWBDQ_START+31"
   
   gCommonErrorRC(32) = "Host error occurred for which no return is defined.  " & _
                        "See the error handle for the message text. " & _
                        "CWBDQ_HOST_ERROR          CWBDQ_START+32"
   
   gCommonErrorRC(99) = "Unexpected error                        : " & _
                        "CWBDQ_UNEXPECTED_ERROR    CWBDQ_START+99"

End Function
